<!DOCTYPE html>
<html>
  <head>
    <title>LETRAS JORGE DUQUE</title>
    <style>
      html, body { margin: 0; padding: 0; overflow: hidden; }
    </style>
  </head>
  <body>
    <script src="js/three.min.js"></script>
	<script src="js/controls/OrbitControls.js"></script>
    <script>
		var scene, aspect, camera, renderer, controls;
		init();
		animate();
		function init(){
			//INICIALIZACIÓN
	        scene = new THREE.Scene();
	        aspect = window.innerWidth / window.innerHeight;
	        camera = new THREE.PerspectiveCamera( 75, aspect, 0.1, 1000);
            scene.background = new THREE.Color( 0xAAAAAA );
	        renderer = new THREE.WebGLRenderer();
	        renderer.setSize( window.innerWidth, window.innerHeight );
	        document.body.appendChild( renderer.domElement );
			controls = new THREE.OrbitControls( camera, renderer.domElement );
			
			//ELEMENTOS COMUNES
			var size = 40;
			var arrowSize = 1;
			var divisions = size;
			var origin = new THREE.Vector3( 0, 0, 0 );
			var x = new THREE.Vector3( 1, 0, 0 );
			var y = new THREE.Vector3( 0, 1, 0 );
		  	var z = new THREE.Vector3( 0, 0, 1 );
		  	var color1 = new THREE.Color( 0x333333 );
			var color2 = new THREE.Color( 0xFFFFFF );
		  	var colorR = new THREE.Color( 0xAA3333 );
		  	var colorG = new THREE.Color( 0x33AA33 );
		  	var colorB = new THREE.Color( 0x333366 );
			
		  	//CREAR LAS GRILLAS PARA EL ESCENARIO
		  	var axesHelper = new THREE.AxesHelper( size );
		  	var gridHelperXY = new THREE.GridHelper( size, divisions, color1, color1);
		  	var gridHelperXZ = new THREE.GridHelper( size, divisions, color2, color2 );
		  	var gridHelperYZ = new THREE.GridHelper( size, divisions, color2, color2 );
            
            //ROTARLAS PARA QUE QUEDEN EN EL ESPACIO ADECUADO
            gridHelperXY.rotateOnWorldAxis ( x, THREE.Math.degToRad(90) );
            gridHelperXZ.rotateOnWorldAxis ( y, THREE.Math.degToRad(90) );
            gridHelperYZ.rotateOnWorldAxis ( z, THREE.Math.degToRad(90) );
            
            //CREAR LAS FLECHAS QUE INDICAN LOS EJES DE COORDENADAS 3D
            var arrowX = new THREE.ArrowHelper( x, origin, arrowSize, colorR );
            var arrowY = new THREE.ArrowHelper( y, origin, arrowSize, colorG );
            var arrowZ = new THREE.ArrowHelper( z, origin, arrowSize, colorB );

            //CREAR ILUMINACIÓN
            var ambient = new THREE.AmbientLight( 0xAAAAAA, 2 );
            scene.add( ambient );
			
            var pointLight = new THREE.PointLight( 0xffffff, 1, 100 );
            pointLight.position.set( -5, 1, 5 );
            scene.add( pointLight );
			
            var pointLight = new THREE.PointLight( 0xffffff, .5, 100 );
            pointLight.position.set( 5, 1, -5 );
            scene.add( pointLight );
			
			//CREAR LAS GEOMETRÍAS
			 var curveD = new THREE.CubicBezierCurve3(
				new THREE.Vector3(1,0,0),
				new THREE.Vector3(1,0,0),
				new THREE.Vector3(1,0,0),
				new THREE.Vector3(1,8,0)
			);
			var curveD2= new THREE.CubicBezierCurve3(
				new THREE.Vector3(1,0,0),
				new THREE.Vector3(7,2,0),
				new THREE.Vector3(7,5,0),
				new THREE.Vector3(1,8,0)
			);
			var curveD3 = new THREE.CubicBezierCurve3(
				new THREE.Vector3(1,0,2),
				new THREE.Vector3(1,0,2),
				new THREE.Vector3(1,0,2),
				new THREE.Vector3(1,8,2)
			)
			var curveD4= new THREE.CubicBezierCurve3(
				new THREE.Vector3(1,0,2),
				new THREE.Vector3(7,2,2),
				new THREE.Vector3(7,5,2),
				new THREE.Vector3(1,8,2)
			);
            var curveJ = new THREE.CubicBezierCurve3(
				new THREE.Vector3(-6,2,0),
				new THREE.Vector3(-6,-1,0),
				new THREE.Vector3(-3,-3,0),
				new THREE.Vector3(-3,9,0)
			);
			var curveJ2= new THREE.CubicBezierCurve3(
				new THREE.Vector3(-2,7,0),
				new THREE.Vector3(-6,7,0),
				new THREE.Vector3(-7,7,0),
				new THREE.Vector3(-6,7,0)
			);
			 var curveJ3 = new THREE.CubicBezierCurve3(
				new THREE.Vector3(-6,2,2),
				new THREE.Vector3(-6,-1,2),
				new THREE.Vector3(-3,-3,2),
				new THREE.Vector3(-3,9,2)
			);
			var curveJ4= new THREE.CubicBezierCurve3(
				new THREE.Vector3(-2,7,2),
				new THREE.Vector3(-6,7,2),
				new THREE.Vector3(-7,7,2),
				new THREE.Vector3(-6,7,2)

			);

			
			var geometria = new THREE.Geometry();
            var geometria2 = new THREE.Geometry();
				for(var i=0;i<20;i++){
					var point = curveD.getPoint(i/20);
					geometria.vertices.push(point);
				}
			
				for(var i=0;i<20;i++){
					var point = curveD2.getPoint(i/20);
					geometria.vertices.push(point);
				}

				for(var i=0;i<20;i++){
					var point = curveD3.getPoint(i/20);
					geometria.vertices.push(point);
				}

				for(var i=0;i<20;i++){
					var point = curveD4.getPoint(i/20);
					geometria.vertices.push(point);
				}
             for(var i=0;i<20;i++){
					var point = curveJ.getPoint(i/20);
					geometria2.vertices.push(point);
				}

				for(var i=0;i<20;i++){
					var point = curveJ2.getPoint(i/20);
					geometria2.vertices.push(point);
				}
             for(var i=0;i<20;i++){
					var point = curveJ3.getPoint(i/20);
					geometria2.vertices.push(point);
				}

				for(var i=0;i<20;i++){
					var point = curveJ4.getPoint(i/20);
					geometria2.vertices.push(point);
				}
             
			
			var pointMaterial = new THREE.PointsMaterial( { color: 0xF6F3ED } );
			var curvePoints = new THREE.Points(geometria, pointMaterial);
            var curvePoints2 = new THREE.Points(geometria2, pointMaterial);
			var material = new THREE.MeshStandardMaterial( { color :  0x65c771 } );
			

			material.side = THREE.DoubleSide;
			//CREAR CARAS
			
			for(var i=0 ; i<39;i++){
				var face1 = new THREE.Face3(i,i+1,i+40);
				geometria.faces.push(face1);
				var face2 = new THREE.Face3(i+1,i+40,i+41);
				geometria.faces.push(face2);
			}
            for(var i=0 ; i<39;i++){
				var face1 = new THREE.Face3(i,i+1,i+40);
				geometria2.faces.push(face1);
				var face2 = new THREE.Face3(i+1,i+40,i+41);
				geometria2.faces.push(face2);
			}
			geometria.computeFaceNormals();
			scene.add(new THREE.Mesh(geometria,material));
            scene.add(new THREE.Mesh(geometria2,material));
			
			//AGREGAR A LA ESCENA
		  	scene.add( gridHelperXZ );	
		  	scene.add( arrowX );	
		  	scene.add( arrowY );	
		  	scene.add( arrowZ );	
			scene.add(curvePoints);
            scene.add(curvePoints2);


		  	camera.position.z = 15 ;
			camera.lookAt( origin );
		}
		function animate(){
			requestAnimationFrame( animate );
			controls.update();
			render();
		}
		function render(){
			renderer.render( scene, camera );
		}
    </script>
  </body>
</html>
